## DBConcept est un outil de modélisation de diagrammes UML et MCD avec génération de code

DBConcept est un logiciel de modélisation de structures et de bases de données. 
À partir d'une description textuelle des contraintes ensemblistes au format 
[Mocodo](https://www.mocodo.net/), selon la finalité souhaitée, il peut générer :

- Le **MCD** (Modèle Conceptuel de Données - [Merise](https://fr.wikipedia.org/wiki/Merise_(informatique)).
- Le **diagramme des classes** ou de domaine [UML](https://fr.wikipedia.org/wiki/UML_(informatique)).
- Le MLD (Modèle Logique de Données) sous la forme d'un schéma relationnel 
ou de tables.
- Le script SQL (Structured Query Language) de création des bases de données 
pour MariaDB / MySQL, PostgreSQL ou SQLite.
- Le code Haxe, Java, PHP ou Python des classes métier.

Il est disponible sous la forme d'une application web ou en ligne de commande.
Un [plugin (filtre) Moodle](https://moodle.org/plugins/filter_dbconcept) est également disponible.

- L'application web, au design adaptatif (ordinateurs, smartphones), propose 
une vue comprenant deux affichages multifonctions pour une comparaison facilitée 
entre différentes représentations.
- La version en ligne de commande (Java) supporte la généreration et la rétro-conception 
de bases de données MariaDB / MySQL ou SQLite.


### Compatibilité et différences avec Mocodo

DBConcept est compatible avec Mocodo, mais sa syntaxe a été enrichie pour 
intégrer les concepts de la programmation orientée objets (OOP) et permettre 
la génération de diagrammes UML et de code.

DBConcept n'intègre pas certaines fonctionnalités de Mocodo, notamment :

- les contraintes sur les associations ;
- le dictionnaire des données ;
- les entités ou classes de même noms (exemple: `Date`) ;
- les symboles <abbr title="Dépendance Fonctionnelle">`DF`</abbr> / <abbr title="Contrainte d'Intégrité Fonctionnelle">`CIF`</abbr> ;
- les cas irréguliers (réduction de clé primaire et suppression des valeurs 
nulles pour les associations de cardinalités 0,1) ;
- les fonctionnalités pédagogiques ;
- l'intégration avec [Jupyter-Notebook](https://jupyter.org/).



## DBConcept est un logiciel libre et gratuit

DBConcept est un logiciel gratuit et libre sous [licence CeCILL 2.1](http://cecill.info/licences/Licence_CeCILL_V2.1-fr.html).  
© Frank ENDRES (frankendres@tuxfamily.org - désactivée, utiliser prénom@nom.fr) - 2020  
*Inspiré par mes professeurs et collègues que je remercie chaleureusement.*

Le design et le theme de la version en ligne sont sous [licence CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).  
© Sandy Grassineau (grassineau@hotmail.fr) - 2020

L'extension (filtre) pour [intégrer DBConcept à la plateforme d'apprentissage Moodle](https://moodle.org/plugins/filter_dbconcept) 
est sous [licence CeCILL 2.1](http://cecill.info/licences/Licence_CeCILL_V2.1-fr.html).
© Erwan Gallenne (Académie de Nantes) - 2021

*DBConcept respecte la vie privée et ne collecte aucune donnée.*


## DBConcept est un logiciel à vocation pédagogique

DBConcept a été conçu pour répondre à des objectifs pédagogiques dans le contexte 
d'un enseignement scientifique et technologique avec dans certains cas une finalité 
professionnelle. Exemples :

- Baccalauréat général, spécialité Numérique et Sciences Informatiques ([NSI](https://eduscol.education.fr/2068/programmes-et-ressources-en-numerique-et-sciences-informatiques-voie-gt)),
- Baccalauréat Sciences et Technologies du Management et de la Gestion ([STMG](https://eduscol.education.fr/1742/programmes-et-ressources-en-serie-stmg)), 
pour l'enseignement spécifique de Systèmes d'Information de Gestion (SIG),
- Brevets de Technicien Supérieur (BTS), notamment en Services Informatiques aux Organisations ([SIO](https://www.reseaucerta.org/sio2019/accueil)),
- Bachelors Universitaire de Technologie (BUT, exemple : [Université de Nantes](https://iutnantes.univ-nantes.fr/formations/bachelor-iut-bac3/but-info)),
- Licences générales et professionnelles,
- Diplômes d'Ingénieurs,
- Masters, notamment en sciences du numérique et du management ([MIAGE](http://www.miage.fr)),
- Titres du Référentiel National de Compétences Professionnelles ([RNCP](https://www.francecompetences.fr/recherche_certificationprofessionnelle/)).


